【Leetcode】120.三角形最小路径和

一、题目

1、题目描述

给定一个三角形 triangle ,找出自顶向下的最小路径和。

每一步只能移动到下一行中相邻的结点上。相邻的结点 在这里指的是 下标 与 上一层结点下标 相同或者等于 上一层结点下标 + 1 的两个结点。也就是说,如果正位于当前行的下标 i ,那么下一步可以移动到下一行的下标 i 或 i + 1 。

示例1:

复制代码
输入:triangle = [[2],[3,4],[6,5,7],[4,1,8,3]]
输出:11
解释:如下面简图所示:
   2
  3 4
 6 5 7
4 1 8 3
自顶向下的最小路径和为 11(即,2 + 3 + 5 + 1 = 11)。

示例2:

复制代码
输入:triangle = [[-10]]
输出:-10

提示:

  • 1 <= triangle.length <= 200
  • triangle[0].length == 1
  • triangle[i].length == triangle[i - 1].length + 1
  • -104 <= triangleij <= 104

进阶:

  • 你可以只使用 O(n) 的额外空间(n 为三角形的总行数)来解决这个问题吗?

2、基础框架

cpp 复制代码
class Solution {
public:
    int minimumTotal(vector<vector<int>>& triangle) {

    }
};

3、原题链接

120.三角形最小路径和

二、解题报告

1、思路分析

动态规划 + 空间优化。

动态规划的经典题目,堪称入门题。

(i,j) 位置看成一个状态,定义 dp[i][j] 表示 从 (i,j) 位置出发得到的最小路径和。在(i,j) 位置有两种决策:向左下走到 (i+1,j) 位置,后续从 (i+1,j) 位置出发得到最小路径和;同理,向右下走到(i+1,j+1) 位置,后续从 (i+1,j+1) 位置出发得到最小路径和。

所以可以得到转移方程:
d p i j = t r i a n g l e i j + m i n ( d p i + 1 j , d p i + 1 j + 1 ) dpij = triangleij + min(dpi+1j, dpi+1j+1) dpij=triangleij+min(dpi+1j,dpi+1j+1)

也就是说,(i,j) 位置的状态依赖于 (i+1,j) 和 (i+1, j+1) 位置的状态,于是逆序枚举 i。见代码详解中的"动态规划"写法。

又(i,j) 位置的状态只依赖于 (i+1,j) 和 (i+1, j+1) 位置的状态,所以用一维数组即可。代码见"动态规划 + 空间优化"写法。

2、时间复杂度

O ( N 2 ) O(N^2) O(N2)

3、代码详解

  • 动态规划
cpp 复制代码
class Solution {
public:
    int minimumTotal(vector<vector<int>>& triangle) {
        int n = triangle.size();

        int dp[n][n];
        memset(dp, 0, sizeof(dp));

        for (int j = 0; j < n; j++) {
            dp[n - 1][j] = triangle[n - 1][j]; //最后一行的状态
        }

        for (int i = n - 2; i >= 0; i--) { //逆序枚举
            for (int j = 0; j <= i; j++) {
                dp[i][j] = triangle[i][j] + min(dp[i + 1][j], dp[i+1][j+1]);
            }
        }

        return dp[0][0];
    }
};
  • 动态规划 + 空间优化
cpp 复制代码
class Solution {
public:
    int minimumTotal(vector<vector<int>>& triangle) {
        int n = triangle.size();

        int dp[n];
        memset(dp, 0, sizeof(dp));

        for (int j = 0; j < n; j++) {
            dp[j] = triangle[n - 1][j]; //最后一行的状态
        }

        for (int i = n - 2; i >= 0; i--) { //逆序枚举
            for (int j = 0; j <= i; j++) {
                dp[j] = triangle[i][j] + min(dp[j], dp[j+1]);
            }
        }

        return dp[0];
    }
};
相关推荐
Navigator_Z36 分钟前
LeetCode //C - 1300. Sum of Mutated Array Closest to Target
c语言·算法·leetcode
凯瑟琳.奥古斯特1 小时前
力扣1016高效解法:剪枝优化技巧
开发语言·c++·算法·leetcode·职场和发展
qz_Serene2 小时前
练习算法题:双指针 -cpp
c++·算法·leetcode·1024程序员节
Nuanyt3 小时前
Hot 100 刷题笔记 · 数组与哈希专题(3 题)
java·笔记·算法·leetcode·哈希算法·1024程序员节
爱读书的小胖3 小时前
LeetCode 274 H 指数 C 语言解题分析
c语言·算法·leetcode·1024程序员节
basketball6164 小时前
动态规划第一章:引论
算法·动态规划·1024程序员节
如何原谅奋力过但无声6 小时前
【LeetCode hot100】代码随想录未cover部分
数据结构·算法·leetcode
文丑颜不良啊7 小时前
LeetCode701~725题目解析
java·leetcode
木井巳9 小时前
【动态规划: 线性dp】解码方法
java·算法·leetcode·动态规划·推荐算法
java_nnnn18 小时前
LeetCode刷题滑动窗口(串联所有单词的子串+最小覆盖的子串)Java
算法·leetcode·职场和发展